DECLARE SUB init (n!)
DECLARE SUB intro ()
DECLARE SUB endtext (n!)
DECLARE FUNCTION spreadsq! (n!)
DECLARE SUB score (a$)
DECLARE FUNCTION spread! (n)
DECLARE FUNCTION satisfaction! (n)
DECLARE SUB PERMU (s1$, s2$, n!)
' Power Assignment Program

' Idea by Murky, individual contributions credited where used.

' All updates/suggestions/Bug reports to murky@lspace.org

' This program expects to find a text file, properly
' formatted, called powin.txt in the directory
'
' The first line should contain the power letters, e.g. aefgirt.
' There should then be a blank line
' Then there should be the power prefs....
' e.g.   aefgirt
'        fgirtae
'        eartfag
'        ratgife
'        targfei
'        rgitaef
'        efgatri
'
' Note. At the moment there is NO ERROR CHECKING. The file must be as
' as above.

COMMON SHARED pref$(), scores(), bestsat, bestspread, bestsq

OPEN "powin.txt" FOR INPUT AS #1
LINE INPUT #1, code$
codelen = LEN(code$)
CLS
' an error checking thing
PRINT code$, codelen
PRINT

' Somewhere to put the prefs
DIM pref$(codelen - 1)
' Somewhere to store scores
DIM scores(codelen - 1)

' skip the blank line which is put there for ease of editing
LINE INPUT #1, pref$(0)

' get the prefs into memory
FOR t = 0 TO codelen - 1
  LINE INPUT #1, pref$(t)
  PRINT pref$(t)
NEXT t
CLOSE #1
PRINT

CALL init(codelen)

OPEN "powout.txt" FOR OUTPUT AS #1

CALL intro
CALL PERMU("", code$, codelen)
CALL endtext(codelen - 1)

CLOSE #1

SUB endtext (n)
  PRINT #1, ""
  PRINT #1, "The player preferences were:"
  PRINT #1, ""
  FOR t = 0 TO n
    PRINT #1, pref$(t)
  NEXT t
  PRINT "See the file powout.txt for the output summary"
END SUB

SUB init (n)
  ' Initialise other data.
  ' Pick a really high value, which is the worst you could get...
  bestsat = n * n
  ' Pick a really High Value, slightly larger than worst poss.
  bestspread = bestsat
  bestsq = bestspread * bestspread
END SUB

SUB intro
  PRINT #1, "This is the output generated by the powers.bas program."
  PRINT #1, "The program is pretty basic, and so an explanation of the"
  PRINT #1, "output is in order."
  PRINT #1, ""
  PRINT #1, "Down the left hand side is the particular combination of"
  PRINT #1, "power assignments being investigated."
  PRINT #1, "aefgirt means that the first player in the preference list"
  PRINT #1, "file gets Austria, the next England, and so on.... bear in"
  PRINT #1, "mind that the symbols actually used depend upon powin.txt"
  PRINT #1, ""
  PRINT #1, "Next come the scores. The lower the score the better."
  PRINT #1, "Note. The program calculates the scores and displays only"
  PRINT #1, "combinations which beat the last best score."
  PRINT #1, "Which measure you use is up to you, but if you use this"
  PRINT #1, "program, do let your players know in advance which scoring"
  PRINT #1, "system you will use to assign powers."
  PRINT #1, ""
  PRINT #1, "The satisfaction score is a measure of how high up on the"
  PRINT #1, "list each choice was."
  PRINT #1, ""
  PRINT #1, "The spread is a simple measure of the difference in satisfaction"
  PRINT #1, "between players.... one large difference works out the same"
  PRINT #1, "as several small differences."
  PRINT #1, ""
  PRINT #1, "Spread SQ benefits an assignment with lots of small differences"
  PRINT #1, "compared to an assignment with one large difference in"
  PRINT #1, "satisfaction "
  PRINT #1, ""
END SUB

SUB PERMU (s1$, s2$, n)

' Thanks to Ben Hutchings for help with this subroutine.
' It has been modified slightly from the code given to me.

  IF n > 1 THEN
    T2$ = ""
    FOR I = 1 TO n
      T1$ = s1$ + MID$(s2$, I, 1)
      T2$ = LEFT$(s2$, I - 1) + RIGHT$(s2$, n - I)
      CALL PERMU(T1$, T2$, n - 1)
    NEXT
  ELSE
    output$ = s1$ + s2$
    leng = LEN(output$)
    score (output$)
    satisfy = satisfaction(leng)
    variance = spread(leng)
    varsquar = spreadsq(leng)
    store = 0
    IF satisfy <= bestsat THEN
      bestsat = satisfy
      store = store + 1
    END IF
    IF variance <= bestspread THEN
      bestspread = variance
      store = store + 2
    END IF
    IF varsquar <= bestsq THEN
      bestsq = varsquar
      store = store + 4
    END IF
    IF store > 0 THEN
       ' Only output if it's a better combo
       PRINT output$;
       PRINT #1, output$;
      
       ' Output all scores for combo - but only the headers
       ' which make is a good combo - run it and you'll see....
       IF store MOD 2 = 1 THEN
         PRINT "  Satis = ";
         PRINT #1, "  Satis = ";
       ELSE
         PRINT #1, "          ";
         PRINT "          ";
       END IF
       IF satisfy < 10 THEN
         PRINT " ";
         PRINT #1, " ";
       END IF
       PRINT satisfy;
       PRINT #1, satisfy;
      
       store = FIX(store / 2)
       IF store MOD 2 = 1 THEN
         PRINT " Spread = ";
         PRINT #1, " Spread = ";
       ELSE
         PRINT "          ";
         PRINT #1, "          ";
       END IF
       IF variance < 10 THEN
         PRINT " ";
         PRINT #1, " ";
       END IF
       PRINT variance;
       PRINT #1, variance;
      
       store = FIX(store / 2)
       IF store MOD 2 = 1 THEN
         PRINT " Spread Sq = ";
         PRINT #1, " Spread Sq = ";
       ELSE
         PRINT "             ";
         PRINT #1, "             ";
       END IF
       IF varsquar < 10 THEN
         PRINT " ";
         PRINT #1, " ";
       END IF
       PRINT varsquar;
       PRINT #1, varsquar;
       PRINT
       PRINT #1, ""
    END IF
 
  END IF
END SUB

FUNCTION satisfaction (n)
  sc = 0
  FOR t = 0 TO n - 1
    sc = sc + scores(t)
  NEXT t
  satisfaction = sc
END FUNCTION

SUB score (a$)
  n = LEN(a$)
  FOR t = 0 TO n - 1
    scores(t) = 0
    pow$ = MID$(a$, t + 1, 1)
    FOR s = 1 TO n
      tmp$ = MID$(pref$(t), s, 1)
      IF tmp$ = pow$ THEN scores(t) = s
    NEXT s
  NEXT t
END SUB

FUNCTION spread (n)
  sc = 0
  worst = 0
  ' Find the person who is worst off
  FOR t = 0 TO n - 1
    IF scores(t) > worst THEN worst = scores(t)
  NEXT t
  ' Give a score based on the difference in satisfaction.
  FOR t = 0 TO n - 1
    sc = sc + worst - scores(t)
  NEXT t
  spread = sc
END FUNCTION

FUNCTION spreadsq (n)
  sc = 0
  worst = 0
  ' Find the person who is worst off
  FOR t = 0 TO n - 1
    IF scores(t) > worst THEN worst = scores(t)
  NEXT t
  ' Give a score based on the SQUARE of difference in satisfaction.
  FOR t = 0 TO n - 1
    tmp = worst - scores(t)
    tmp = tmp * tmp
    sc = sc + tmp
  NEXT t
  spreadsq = sc

END FUNCTION

